include:
  - local: 'job-artifacts/.gitlab-ci.yml'
  - local: 'job-cache/.gitlab-ci.yml'
  - local: 'container-registry-docker/.gitlab-ci.yml'
  - local: 'container-registry-kaniko/.gitlab-ci.yml'
  - local: 'maven-repository/.gitlab-ci.yml'
  - local: 'npm-registry/.gitlab-ci.yml'
  - local: 'nuget-repository/.gitlab-ci.yml'
  - local: 'pypi-repository/.gitlab-ci.yml'
  - local: 'generic-package/.gitlab-ci.yml'
  - local: 'pages/.gitlab-ci.yml'
  - local: 'helm/.gitlab-ci.yml'
  - local: 'dependency-proxy/.gitlab-ci.yml'
  - local: 'conan-registry/.gitlab-ci.yml'

.shared-rules:
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: always
    - if: $RUN_ALL_TESTS
      when: always
    - when: manual
      allow_failure: true

.optional-features:
  allow_failure: true

stages:
  - optional-features
  - test
  - deploy

container-registry-docker:
  extends: .shared-rules

container-registry-kaniko:
  extends: .shared-rules

job-artifacts:upload:
  extends: .shared-rules

job-artifacts:download:
  extends: .shared-rules

job-cache:upload:
  extends: .shared-rules

job-cache:download:
  extends: .shared-rules

maven-repository:mvn:
  extends: .shared-rules

maven-repository:gradle:
  extends: .shared-rules

npm-registry:
  extends: .shared-rules

nuget-repository:
  extends: .shared-rules

pypi-repository:
  extends: .shared-rules

generic-package:create:
  extends: .shared-rules

generic-package:download:
  extends: .shared-rules

pages:
  extends: .shared-rules

helm:create:
  extends: .shared-rules

helm:download:
  extends: .shared-rules

dependency-proxy:
  extends:
    - .shared-rules
    - .optional-features

conan-registry:
  extends: .shared-rules

debug:
  extends: .shared-rules
  stage: test
  script:
  - env | sort
